var map = false;

var gameState = {
  
};

var rules = {

  maxX : 20,
  maxY : 10,
  
  xpGoal : function(lv) {
    return(Math.pow(lv*5, 2));
  },
  
  chooseRandom : function(ar) {
    return(ar[Math.floor(ar.length * Math.random())]);
  },
  
  copy : function(orig) {
    var result = {};
    $.each(orig, function(idx, itm) {
      result[idx] = itm;
    });
    return(result);
  },
  
  randomPos : function() {
    var pos;
    do {
      pos = {
        x : Math.round(Math.random()*rules.maxX),
        y : Math.round(Math.random()*rules.maxY),
      };
    } while(!rules.canMoveTo({}, pos.x, pos.y))
    return(pos);
  },
  
  canMoveTo : function(mob, x, y) {
    mob.collidesWith = false;
    if(x < 0) return(false);
    if(y < 0) return(false);
    if(x > rules.maxX) return(false);
    if(y > rules.maxY) return(false);
    var occupied = false;
    $.each(game.units, function(idx, unit) {
      if(unit.pos.x == x && unit.pos.y == y) {
        occupied = true;
        mob.collidesWith = unit;
      }
      });
    return(!occupied);
  },
  
  roll : function(max) {
    return(Math.round(Math.random()*max));
  },
  
  doAttack : function(attacker, target, verb) {
    var dmg;
    if(!verb) verb = 'attacks';
    var eventText = [attacker.getIdent(), verb, target.getIdent()];
    var hitRoll = rules.roll(100);
    var isCritical = false;
    if(hitRoll <= attacker.getRating('skill')) {
      eventText.push('and hits for ');
      dmg = attacker.stats.level + rules.roll(attacker.getRating('damage')) - target.getRating('protection');
      var hitSkill = attacker.getRating('skill');  
      while(hitSkill >= 75) {
        hitSkill -= 75;
        if(rules.roll(100) <= 30) {
          dmg += attacker.stats.level + rules.roll(attacker.getRating('damage')) - target.getRating('protection');
          isCritical = true;
        }
      }
      if(dmg < 1) dmg = 1;
      UI.actionMarker((attacker.pos.x + target.pos.x) / 2, (attacker.pos.y + target.pos.y) / 2, '*');
      eventText.push(dmg);
      if(isCritical) eventText.push('critical');
      eventText.push('damage');
      target.takeDamage(dmg, attacker);
    } else {
      eventText.push('and misses.')
    }    
    UI.log(eventText.join(' '));
    return(dmg);
  },
  
  doLoot : function(receiver, bodyLevel) {
    if(rules.roll(100) <= 50 + bodyLevel*10) {
      var lootLevel = rules.roll(bodyLevel / 3);
      var item = rules.copy(rules.chooseRandom(lootTable));
      if(item.name != 'none') {
        if(lootLevel > 0) {
          item.bonus = lootLevel;
          item.name = item.name + ' +'+item.bonus;
          if(item.damage) item.damage += item.bonus*2;
          if(item.protection) item.protection += item.bonus;
          if(item.skill) item.skill += item.bonus*5;
          if(item.power) item.power += item.power*item.bonus;
        }
        receiver.inventory.unshift(item);
        UI.delayedLog('* looted '+item.name);
      }
    }
  },
  
};

var AI = {
  
  noop : function(){ },
  
  // friendly mobs:
  tickFriendly : function(mob) {
    var action = Math.round(Math.random()*1);
    switch(action)
    {
      case(0): {
        mob.move(Math.round(Math.random()*2)-1, Math.round(Math.random()*2)-1);
        break;
      }
    }
  },
  
  normalAttack : function(attacker, target) {
    rules.doAttack(attacker, target);
  },
  
  drainAttack : function(attacker, target) {
    var drain = rules.doAttack(attacker, target, 'greases');
    if(drain > 0) {
      attacker.stats.hpcurrent += drain;
      //UI.delayedLog(attacker.stats.name+' drains '+drain+' HP');
    }
  },
  
  normalMove : function(mob, xdif, ydif) {
    mob.updatePosition(xdif, ydif);
  },
  
  attackMove : function(mob, xdif, ydif) {
    mob.updatePosition(xdif, ydif);
    if(mob.collidesWith) mob.attack(mob.collidesWith);
  },
  
  normalDamageBehavior : function(mob, attacker, amount) {
    
  },
  
  counterAttack : function(mob, attacker, amount) {
    mob.attack(attacker);
  },
  
  
}

var MobWeapons = {
  
  hands : { type : 'weapon', name : 'hands', damage : 2, },
  claw : { type : 'weapon', name : 'claw', damage : 5, },
  fangs : { type : 'weapon', name : 'fangs', damage : 10, },

};

var Items = {
  
  club : { type : 'weapon', name : 'club', damage : 3, },
  dagger : { type : 'weapon', name : 'dagger', damage : 7, },
  sword : { type : 'weapon', name : 'sword', damage : 10, },
  
  none : { type : 'armor', name : 'none', protection : 0 },
  leather : { type : 'armor', name : 'leather', protection : 2 },
  chain : { type : 'armor', name : 'chain mail', protection : 4 },
  plate : { type : 'armor', name : 'plate', protection : 6 },

  skillRing : { type : 'ring', name : 'ring of skill', skill : 5 },
  damageRing : { type : 'ring', name : 'ring of rage', damage : 5 },
  protRing : { type : 'ring', name : 'ring of protection', protection : 1 },

  healPotion : { type : 'consumable', name : 'potion of healing', power : 10, consume : function(item, userMob) { userMob.heal(item.power); } },
  healPotion : { type : 'consumable', name : 'healing scroll', power : 12, consume : function(item, userMob) { userMob.heal(item.power); } },
  healPotion : { type : 'consumable', name : 'ointment', power : 7, consume : function(item, userMob) { userMob.heal(item.power); } },
  healPotion : { type : 'consumable', name : 'badger essence', power : 5, consume : function(item, userMob) { userMob.heal(item.power); } },
  healPotion : { type : 'consumable', name : 'bacon grease', power : 3, consume : function(item, userMob) { userMob.heal(item.power); } },
  healPotion : { type : 'consumable', name : 'magic lemonade', power : 2, consume : function(item, userMob) { userMob.heal(item.power); } },
  
}
var lootTable = [];
$.each(Items, function(idx, itm) {
  lootTable.push(itm);
});


/************ MOB CLASSES *******************************************/

var mobClasses = {
  
  player : function(o) {
    o.pos = { x : 5, y : 5 };
    o.symbolCode = '@';
    o.symbolClass = 'em';
    o.moveBehavior = AI.attackMove;
    o.attackBehavior = AI.normalAttack;
    o.getIdent = function() { return('the player'); };
    rules.doLoot(o, 8);
  },
  
  grue : function(o) {
    o.stats.hp = 3;
    o.symbolCode = 'G';
    o.aiTick = AI.tickFriendly;
  },
  
  bacon : function(o) {
    o.stats.hp = 1;
    o.symbolCode = 'b';
    o.aiTick = AI.tickFriendly;
    o.stats.weapon = MobWeapons.hand;
    o.damageBehavior = AI.counterAttack;  
    o.attackBehavior = AI.drainAttack;  
  },

  chunkyBacon : function(o) {
    o.stats.hp = 5;
    o.stats.weapon = Items.dagger;
    o.symbolCode = 'c';
    o.stats.name = 'chunky bacon';
    o.aiTick = AI.tickFriendly;
    o.damageBehavior = AI.counterAttack;  
    o.attackBehavior = AI.normalAttack;  
  },
  
  badger : function(o) {
    o.stats.hp = 3;
    o.stats.weapon = MobWeapons.claw;
    o.symbolCode = 'B';
    o.stats.name = rules.chooseRandom(['smelly', 'battered', 'rabid'])+' badger';
    o.aiTick = AI.tickFriendly;
    o.damageBehavior = AI.counterAttack;  
    o.attackBehavior = AI.normalAttack;  
  },
  
  undeadBadger : function(o) {
    o.stats.hp = 7;
    o.stats.weapon = MobWeapons.fangs;
    o.symbolCode = 'u';
    o.stats.name = rules.chooseRandom(['rotting', 'zombie', 'undead', 'vampire'])+' badger';
    o.aiTick = AI.tickFriendly;
    o.damageBehavior = AI.counterAttack;  
    o.attackBehavior = AI.drainAttack;  
  },
  
};

var mobCounter = 1;
var makeMob = function(className, dpos, lvlBase) {

  var sid = 'M'+mobCounter++;
  
  var mob = {
  
    stats : {
      name : className,
      hp : 10,
      armor : 0,
      skill : 50,
      weapon : Items.club,
      armor : Items.none,
      level : 1,
      xp : 0,
    },
    inventory : [],
        
    pos : dpos ? dpos : rules.randomPos(),
    
    className : className,
    
    init : function() {
      game.units.push(mob);
      if(mobClasses[className]) 
        mobClasses[className](mob);
      else
        console.log('unknown class template: '+className);
      if(lvlBase)
        mob.levelUp(lvlBase);
      mob.stats.hpcurrent = mob.stats.hp;
      gameState.playerSymbol = map.append('<div id="'+sid+'" class="symbol '+mob.symbolClass+'"><div class="lvlSymbol">'+mob.stats.level+'</div>'+mob.symbolCode+'</div>');
      return(mob);
    },
    
    getIdent : function() {
      return('a level '+mob.stats.level+' '+mob.stats.name);
    },
    
    getRating : function(statName) {
      var result = mob.stats[statName];
      if(!result) result = 0;
      $.each(mob.stats, function(idx, stype) {
        if(stype && stype[statName]) result += stype[statName];
      });
      return(result);
    },
    
    damageBehavior : AI.normalDamageBehavior,
    takeDamage : function(amount, from) {
      mob.stats.hpcurrent -= amount;
      UI.actionMarker(mob.pos.x, mob.pos.y, '-'+amount, 0.1, true);
      mob.damageBehavior(mob, from, amount);
      if(mob.stats.hpcurrent <= 0) {
        mob.die(from);
      }
    },
    
    moveBehavior : AI.normalMove,    
    move : function(x, y) { mob.moveBehavior(mob, x, y); },

    attackBehavior : AI.noop,
    attack : function(target) { mob.attackBehavior(mob, target); },

    die : function(by) {
      by.receiveXP(mob.stats.level+Math.round(mob.stats.hp/5));
      rules.doLoot(by, mob.stats.level);
      UI.delayedLog(mob.getIdent()+' is killed by '+by.getIdent());
      game.units.splice(game.units.indexOf(mob), 1);
      $('#'+sid).addClass('dead').fadeOut('slow');
      setTimeout(function() {
        $('#'+sid).remove();  
        }, 3000);
      mob.stats.dead = true;
    },
    
    receiveXP : function(amount) {
      mob.stats.xp += amount;
      if(mob.stats.xp >= rules.xpGoal(mob.stats.level)) {
        mob.levelUp();
      }
    },
    
    levelUp : function(lvlDiff) {
      if(!lvlDiff) lvlDiff = 1;
      mob.stats.level += lvlDiff;
      mob.stats.skill += 5*lvlDiff;
      var hpIncrease = 0;
      if(mob == game.player) {
        UI.delayedLog('*** Level up! You are now level '+mob.stats.level+' ***');
        hpIncrease = 5*lvlDiff;
        $('#'+sid+' > .lvlSymbol').text(mob.stats.level);
      } else {
        hpIncrease = (mob.stats.hp*2)*lvlDiff;
      }
      mob.stats.hp += hpIncrease;
      mob.stats.hpcurrent = mob.stats.hp;
    },
    
    heal : function(amount) {
      if(!amount) amount = 1;
      mob.stats.hpcurrent += amount;
      var hpMax = mob.getRating('hp');
      if(mob.stats.hpcurrent > hpMax) mob.stats.hpcurrent = hpMax;
      UI.log('healed!');
    },
    
    equip : function(inventoryIdx) {
      var item = mob.inventory[inventoryIdx];
      if(item) {
        mob.inventory.splice(mob.inventory.indexOf(item), 1);
        if(item.type == 'consumable') {
          item.consume(item, mob);
        } else {
          var oldSlotItem = mob.stats[item.type];
          mob.stats[item.type] = item;
          mob.inventory.push(oldSlotItem);
        }
      }
    },
    
    updatePosition : function(xdif, ydif) {
      if(rules.canMoveTo(mob, mob.pos.x + xdif, mob.pos.y + ydif)) {
        mob.pos.x += xdif;
        mob.pos.y += ydif;
      }
      $('#'+sid).css('left', mob.pos.x*32).css('top', mob.pos.y*32);
    },
    
  };
  
  mob.init();  
  mob.updatePosition(0, 0);
  return(mob);
  
};

var Levels = [
  {
    name : 'Grue Warmup Level',
    objective : 'Ew! This room is full of Grues and stuff. Clear it!',
    tick : function(game) {  
      if(game.countUnits() == 0) {
        UI.log('You have cleared all the grues.');
        game.fLevelIndex++;
        game.startLevel(0);
      }
    },
    init : function(game) {
      game.generateMobs('grue', 5);
      if(game.player.stats.level > 3)
        game.generateMobs('badger', rules.roll(3));
      game.generateMobs('bacon', rules.roll(5));
      if(game.player.stats.level > 5)
        game.generateMobs('chunkyBacon', rules.roll(3));
      if(game.player.stats.level > 7)
        game.generateMobs('undeadBadger', rules.roll(3));
    },
  },
  {
    name : 'Warmup Grue Level',
    objective : 'This room is full of 20 Grues. Clear it!',
    tick : function(game) {  
      if(game.countUnits('grue') == 0) {
        UI.log('You have cleared all the grues.');
        game.startLevel(1);
      }
    },
    init : function(game) {
      for(var i = 0; i < 20; i++)
        makeMob('grue');
    },
  },
  ];

var game = {

  units : [],
  
  tick : function() {
    // handle game tick
    if(game.halt) return;
    $.each(game.units, function(idx, unit) {
      if(unit.aiTick) unit.aiTick(unit);
    });
    UI.logSpool();
    game.currentLevel.tick(game);
    UI.displayStats(game.player.stats);
  },
  
  generateMobs : function(className, count) {
    for(var i = 0; i < count; i++)
      makeMob(className, false, rules.roll(game.player.stats.level));
  },
  
  countUnits : function(className) {
    var result = 0;
    $.each(game.units, function(idx, unit) {
      if((unit.className != 'player') && (!className || unit.className == className))
        result += 1;
    });
    return(result);
  },
  
  keyHandler : function(event) {
    var chCode = ('charCode' in event) ? event.charCode : event.keyCode;
    if(game.altKeyHandler) return(game.altKeyHandler(chCode, event.keyCode));
    if(game.halt) return;
    //console.log(chCode);
    if(chCode >= 49 && chCode <= 57) {
      game.player.equip(chCode-49);
    }
    else if(chCode == 105) {
      UI.inventoryScreen();
    }
    else switch(event.keyCode)
    {
      case(38): {
        game.player.move(0, -1);
        break;
      }
      case(40): {
        game.player.move(0, 1);
        break;
      }
      case(37): {
        game.player.move(-1, 0);
        break;
      }
      case(39): {
        game.player.move(1, 0);
        break;
      }
    }
    game.tick();
  },
  
  fLevelIndex : 1,
  currentLevelIndex : 0,
  currentLevel : false,
  startLevel : function(lvl) {
    map.css('background', '#fff');
    game.player.stats.hpcurrent = game.player.stats.hp;
    game.currentLevelIndex = lvl;
    game.currentLevel = Levels[game.currentLevelIndex];
    UI.log(game.currentLevel.objective);
    game.currentLevel.init(game);
    $('#title').text(game.currentLevel.name+' '+game.fLevelIndex);
    setTimeout(function() {
      map.css('background', '#000');
      }, 500);
  },
  
  init : function(mapElement) {
    map = mapElement;
    game.player = makeMob('player');
    game.startLevel(0);
    $('body').keypress(game.keyHandler);
    game.tick();
    UI.log();
    //setInterval(game.tick, 1000);
  },
  
};

var UI = {

  actionMarker : function(x, y, txt, anim) {
    var sid = 'A'+mobCounter++;
    map.append('<div id="'+sid+'" class="marker" style="left:'+(x*32)+'px;top:'+(y*32)+'px">'+txt+'</div>');
    if(anim) {
      $('#'+sid).animate({
        top: "-=16",
        opacity : 0,
        }, 1500, function() { $('#'+sid).remove() });
    } else {
      $('#'+sid).fadeOut(1500);
      setTimeout(function() { $('#'+sid).remove() }, 1500)
    }
  },

  deferredLog : [],
  logLines : ['You are the @. Move around and attack with the cursor keys.'],
  delayedLog : function(str) {
    UI.deferredLog.push(str);
  },
  logSpool : function() {
    if(UI.deferredLog.length > 0) $.each(UI.deferredLog, function(idx, str) {
      UI.log(str);
    });
    UI.deferredLog = [];
  },
  log : function(str) {
    while(UI.logLines.length > 4) UI.logLines.shift();
    $('#description').html(UI.logLines.join("<p/>"));
    if(str) {
      UI.logLines.push(str);
      $('#description').append('<p class="em">'+str+'</p>');
    }
  },

  cursor : '<img src="img/cursor.gif" align="absmiddle" id="cursor"/>',
  
  makeItemList : function(rawList, showIndx, cat) {
    var result = [];
    if (!cat) cat = ', ';
    $.each(rawList, function(idx, itm) {
      if(itm && itm.name != 'none') {
        var desc = [];
        if(itm.protection) desc.push('prot '+itm.protection);
        if(itm.skill) desc.push('+'+itm.skill+'%');
        if(itm.damage) desc.push('dmg '+itm.damage);
        if(itm.power) desc.push('pwr '+itm.power);
        result.push(
          (showIndx ? showIndx(idx, itm, desc) : '')+
          itm.name+(desc.length > 0 ? ' (' : '')+desc.join(' ')+(desc.length > 0 ? ')' : ''));
      }
    });    
    return(result.join(cat)+(result.length == 0 ? '(empty)' : ''));
  },
  
  getInventory : function() {
    var eqList = [ game.player.stats.weapon, game.player.stats.armor ];
    if(game.player.stats.ring) eqList.push(game.player.stats.ring);
    return(
      '<span class="hotkey">i</span>nventory: '+
      UI.makeItemList(game.player.inventory, function(idx) { return('<span class="smallidx">'+(idx+1)+'</span>'); })+
      '<br/>'+'equipped: '+UI.makeItemList(eqList));
  },
  
  displayStats : function(stats) {
    if(stats.dead) {
      $('body').append('<div id="blanket"><div id="popup">You have died. :..( <br/><a onclick="document.location.reload();">Click here to start over</a>.<div></div></div>');
      game.halt = true;
    } 
    $('#info').html(
      'HP='+stats.hpcurrent+'/'+stats.hp+
      ' Armor='+game.player.getRating('protection')+
      ' Skill='+game.player.getRating('skill')+'%'+
      ' Damage='+(stats.level)+'-'+(stats.level+game.player.getRating('damage'))+
      ' Lvl='+stats.level+
      ' XP='+stats.xp+'/'+rules.xpGoal(stats.level)+
      UI.cursor+
      '<br/>'+
      UI.getInventory()
      );
  }, 
  
  invSelItem : false,
  invSelItemIdx : false,
  displayInventoryList : function() {
    $('#popupWindow').html('Inventory<div id="invSel">------</div><br/>').append(UI.makeItemList(game.player.inventory, function(idx) { return('#'+(idx+1)+' '); }, '<br/>'));
  },
  inventoryScreen : function() {
    game.halt = true;
    UI.invSelItemIdx = false;
    game.altKeyHandler = function(chCode) {
      if(chCode >= 49 && chCode <= 57) {
        UI.invSelItemIdx = chCode-49;
        var invSelItem = game.player.inventory[UI.invSelItemIdx];
        if(invSelItem.consume)
          $('#invSel').text('> '+invSelItem.name+': [d]rop [c]onsume [esc]?');
        else
          $('#invSel').text('> '+invSelItem.name+': [d]rop [e]quip [esc]?');
      } else if(chCode == 99) { // c
        if(UI.invSelItemIdx !== false) {
          game.player.equip(UI.invSelItemIdx);
          UI.invSelItemIdx = false;
          UI.displayInventoryList(); 
        }
      } else if(chCode == 100) { // d
        if(UI.invSelItemIdx !== false) {
          game.player.inventory.splice(UI.invSelItemIdx, 1);
          UI.invSelItemIdx = false;
          UI.displayInventoryList(); 
        }
      } else if(chCode == 101) { // e
        if(UI.invSelItemIdx !== false) {
          game.player.equip(UI.invSelItemIdx);
          UI.invSelItemIdx = false;
          UI.displayInventoryList(); 
        }
      } else {
        console.log(chCode);
        $('#blanket').remove();
        game.halt = false;
        game.altKeyHandler = false;
        UI.displayStats(game.player.stats);
      }
    };
    $('body').append('<div id="blanket"><div id="popupWindow"></div></div>');
    UI.displayInventoryList();    
  },
  
};





